/*
 *  DVDSubEdit and this code is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  DVDSubEdit and this code are distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
*/

#include "stdafx.h"
#include "DVDSubEdit.h"
#include "MiscDialogs.h"
#include "SubPic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CApplyToAllDlg dialog


CApplyToAllDlg::CApplyToAllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CApplyToAllDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CApplyToAllDlg)
	m_ApplyVMove = FALSE;
	m_ApplyHMove = FALSE;
	m_ApplyStart = FALSE;
	m_ApplyTransp = FALSE;
	m_ApplyBorders = FALSE;
	m_ApplyDuration = FALSE;
	m_ApplyColor = FALSE;
	m_ApplyCrop = FALSE;
	m_MinMax = 0;
	m_Duration = _T("");
	//}}AFX_DATA_INIT
}


void CApplyToAllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CApplyToAllDlg)
	DDX_Check(pDX, IDC_APPLY_MOVE, m_ApplyVMove);
	DDX_Check(pDX, IDC_APPLY_MOVEH, m_ApplyHMove);
	DDX_Check(pDX, IDC_APPLY_START, m_ApplyStart);
	DDX_Check(pDX, IDC_APPLY_TRANSP, m_ApplyTransp);
	DDX_Check(pDX, IDC_APPLY_BORDER, m_ApplyBorders);
	DDX_Check(pDX, IDC_APPLY_DURATION, m_ApplyDuration);
	DDX_Check(pDX, IDC_APPLY_COLOR, m_ApplyColor);
	DDX_CBIndex(pDX, IDC_DURMINMAX, m_MinMax);
	DDX_Text(pDX, IDC_DURATION, m_Duration);
	DDX_Check(pDX, IDC_APPLY_CROP, m_ApplyCrop);
	//}}AFX_DATA_MAP
}

void CApplyToAllDlg::ResetAllCheck()
{
	m_ApplyVMove = m_ApplyHMove = m_ApplyStart = m_ApplyTransp = m_ApplyBorders = m_ApplyDuration = 
		m_ApplyColor = m_ApplyCrop = false;
}

bool CApplyToAllDlg::AnyChecked()
{
	return 	m_ApplyVMove || m_ApplyHMove || m_ApplyStart || m_ApplyTransp || m_ApplyBorders || 
		m_ApplyDuration || m_ApplyColor || m_ApplyCrop;
}



BEGIN_MESSAGE_MAP(CApplyToAllDlg, CDialog)
	//{{AFX_MSG_MAP(CApplyToAllDlg)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CApplyToAllDlg message handlers


CMoveDlg::CMoveDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMoveDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMoveDlg)
	m_ChangeTimingBy = 0.0f;
	//}}AFX_DATA_INIT
}


void CMoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMoveDlg)
	DDX_Control(pDX, IDC_ABSOLUTE, m_MoveSelect);
	DDX_Text(pDX, IDC_MOVEAMOUNT, m_ChangeTimingBy);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMoveDlg, CDialog)
	//{{AFX_MSG_MAP(CMoveDlg)
	ON_CBN_SELCHANGE(IDC_ABSOLUTE, OnSelchangeAbsolute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CMoveDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_MoveSelect.SetCurSel(0);
	m_CurSel = 0;
	m_MoveSelect.EnableWindow(!m_RetimeAll);
	SetWindowText(m_RetimeAll?"Change timing for all selected subpics":
		"Change timing for the current subpic");
	((CEdit*)GetDlgItem(IDC_MOVEAMOUNT))->SetSel(0,-1);
//	::SetFocus(GetDlgItem(IDC_MOVEAMOUNT)->m_hWnd);
		
	return TRUE; 
}

void CMoveDlg::OnOK() 
{
	m_CurSel = m_MoveSelect.GetCurSel();
	CDialog::OnOK();
}

void CMoveDlg::OnSelchangeAbsolute() 
{
	::SetFocus(GetDlgItem(IDC_MOVEAMOUNT)->m_hWnd);
}

//______________________________________
CPickColorDlg::CPickColorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPickColorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPickColorDlg)
	//}}AFX_DATA_INIT
	m_WindowTitle = 0;
	m_SelectedCol = m_InitSelectedCol = -1;
	m_WhichPixel = -1;
	m_MyRect.top = m_MyRect.bottom = 0;
}


void CPickColorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPickColorDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPickColorDlg, CDialog)
	//{{AFX_MSG_MAP(CPickColorDlg)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_COLB, IDC_COLB16, OnColClick )
END_MESSAGE_MAP()


BOOL CPickColorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	if(m_MyRect.Height() != 0)
	{
		MoveWindow(&m_MyRect);
	}
	if(m_WindowTitle) SetWindowText(m_WindowTitle);
	
	if(m_Engine->m_SelectedSubPic != 0 && m_Engine->m_SelectedSubPic->m_CLUT != 0)
	{
		int i;
		for(i=0;i<m_Engine->m_CLUTV.size();i++)
		{
			if(m_Engine->m_CLUTV[i]->m_CLUT[0] == m_Engine->m_SelectedSubPic->m_CLUT)
				break;
		}
		// It's possible we won't find that CLUT if the IFO was loaded separately.
		if(i < m_Engine->m_CLUTV.size())
		{
			char Temp[1024];
			if(m_Engine->m_CLUTV[i]->m_LU[0] > 0)
				sprintf(Temp,"CLUT in use is defined in\r\nLU %d / PGC %d",m_Engine->m_CLUTV[i]->m_LU[0],
					m_Engine->m_CLUTV[i]->m_PGC[0]);
			else
				sprintf(Temp,"CLUT in use is defined in\r\nPGC %d",m_Engine->m_CLUTV[i]->m_PGC[0]);
			SetDlgItemText(IDC_INFO,Temp);
		}
	}

	m_InitSelectedCol = m_SelectedCol;
	return TRUE;
}

void CPickColorDlg::OnPaint() 
{
	if(m_Engine->m_SelectedSubPic == 0 || m_Engine->m_SelectedSubPic->m_CLUT == 0)
		return;
	PAINTSTRUCT Ps;
	BeginPaint(&Ps);
	int i;
	unsigned char* CLUT = m_Engine->m_SelectedSubPic->m_CLUT;
	HDC TheDC = Ps.hdc;
	CRect Temp;
	uint ID;
	HBRUSH Black = (HBRUSH)CreateSolidBrush(RGB(0,0,0));
	for(i=0;i<16;i++)
	{
		ID = IDC_COLB+i;
		GetDlgItem(ID)->GetWindowRect(&Temp);
		ScreenToClient(&Temp);
		HBRUSH Color = (HBRUSH)CreateSolidBrush(RGB(CLUT[3*i],CLUT[3*i+1],CLUT[3*i+2]));
		FillRect(TheDC,Temp,Color);
		FrameRect(TheDC,&Temp,Black);
		DeleteObject(Color);
	}
	if(m_SelectedCol >= 0)
	{
		GetDlgItem(IDC_SELECTEDCOL)->GetWindowRect(&Temp);
		ScreenToClient(&Temp);
		HBRUSH Color = (HBRUSH)CreateSolidBrush(RGB(CLUT[3*i],CLUT[3*i+1],CLUT[3*i+2]));
		FillRect(TheDC,Temp,Color);
		FrameRect(TheDC,&Temp,Black);
		DeleteObject(Color);
	}
	DeleteObject(Black);
	EndPaint(&Ps);
}

void CPickColorDlg::OnColClick(UINT nID) 
{
	m_SelectedCol = nID-IDC_COLB;
	InvalidateRect(0,0);
	m_Engine->m_SelectedSubPic->m_ColorPtr[m_WhichPixel] = m_SelectedCol;
	m_Engine->ViewSPU(m_Engine->m_SPUSlider.GetPos());
}


void CPickColorDlg::OnCancel() 
{
	m_SelectedCol = m_InitSelectedCol;
	m_Engine->m_SelectedSubPic->m_ColorPtr[m_WhichPixel] = m_SelectedCol;
	m_Engine->ViewSPU(m_Engine->m_SPUSlider.GetPos());
	CDialog::OnCancel();
}

void CPickColorDlg::OnDestroy() 
{
	GetWindowRect(&m_MyRect);
	CDialog::OnDestroy();
}
